#include <stdio.h>
#include <signal.h>
#include <unistd.h>

struct Comp {
  void (*handler) (void*, int);
  void* buf;
  int   siz;
};

struct Comp comp[1000];
int compHead = 0;
int compTail = 0;

void doAsync (void (*aHander)(void*, int), void* aBuf, int aSiz) {
  compHead = (compHead + 1) % (sizeof (comp) / sizeof (struct Comp));
  comp[compHead].handler = aHander;
  comp[compHead].buf     = aBuf;
  comp[compHead].siz     = aSiz;
}
              
void interruptServiceRoutine () {
  struct Comp c;
  if (compHead != compTail) {
    compTail = (compTail + 1) % (sizeof (comp) / sizeof (struct Comp));
    c = comp[compTail];
    c.handler (c.buf, c.siz);
  }
}

void printString (void* buf, int siz) {
  printf ("%s\n", (char*) buf); fflush (stdout);
}

void boot () {
  signal (SIGALRM, interruptServiceRoutine);
  ualarm (999999,999999);
}

int main (int argc, char** argv) {
  boot ();
  printf ("Scheduling some things to do asynchronously\n"); fflush (stdout);
  doAsync (printString, "Thing 1", 0);
  doAsync (printString, "Thing 2", 0);
  doAsync (printString, "Thing 3", 0);
  printf ("Now waiting for them to complete\n"); fflush (stdout);
  while (1);
}